import java.io.*;
import java.util.*;


/**
 *  FormCSQL  Class
 */

public class FormCSQL { 

   FormCDataParser fc; 
   

  /**
   * FormCSQL   Constructor
   */
   
   public FormCSQL(FormCDataParser _fc) {
   		fc = _fc;
   } 	
	


  /**
   * generateFormCSQL 	    Mehtod 
   *
   * @parm 		String[]	fieldNames
   * @parm 		String[]	fieldValues
   * @return    String  
   */

	public String generateFormCSQL(String[] fieldNames, String[] fieldValues) {
		
		int courseKeyIndex = fc.getCourseKeyIndex();
		String students[]	= 
				fc. getCourseStudentsIdByKey(courseKeyIndex);
		
		String studentsData[][] = getData(students, fieldNames, fieldValues);
		
		String formCSqlRows[] = getFormCSqlRows(courseKeyIndex, studentsData);	
			
		createFormCSql(formCSqlRows);
		
		return printSqlRows(formCSqlRows);				
	}	
	
	
  /**
   * getData    Mehtod 
   *
   * @parm 		String[]		students
   * @parm 		String[]		fieldNames
   * @parm 		String[]		fieldValues
   * @return    String[][]  
   */

	public String[][] getData(String students[], String fields[],
												 String fValues[]) {
		
		int noOfRows = students.length;
		int noOfColumns = 9;	// student id + 8 codes

		String data[][] = new String[noOfRows][noOfColumns];
		
		for (int i = 0; i < data.length; i++) {
			for (int j = 0; j < data[i].length; j++) {
				switch (j) {
					case 0:
						data[i][j] = students[i];
						break;

					default:
						for(int k = 0; k < fields.length; k++) {
							if(fields[k].equals("cbo" + (i) + (j-1))) {
 								data[i][j] = fValues[k];
								break;
							}	
						}	
						break;			
				}
			}
   
        }	
        
        return data;
	}
	

  /**
   * getFormCSqlRows        Mehtod 
   *
   * @parm 					int				courseKeyIndex
   * @parm 					String[][]		studentsdata
   * @return    			String[] 
   */

	public String[] getFormCSqlRows(int index, String [][] studentsData) {
 		
 		Vector sqlRows = new Vector();
 		
 		for (int i = 0; i < studentsData.length; i++) {
 			getFormCSqlRow(sqlRows, getFormCRow(index, studentsData[i]));
 		}
		 
		return (vectorToString(sqlRows));
	}
	
	
  /**
   * getFormCSqlRow         Mehtod 
   *
   * @parm 					Vector			vSql
   * @parm 					Vector			vData
   * @return    			void 
   */

	public void getFormCSqlRow(Vector vSql, Vector vData) {		
	
		for (Enumeration e = vData.elements(); e.hasMoreElements();) {
			String strObj[] = (String [])e.nextElement();			  	 
	
			String sql = "Insert into all_forms values (";
		
			for (int i = 0; i < strObj.length; i++) {
				if (i == 0) {
					sql = sql + strObj[i] + ","; 
				}	
				else if(i < (strObj.length - 1)) {
					sql = sql + Html.quote(strObj[i]) + ","; 
				}	
				else {	
					sql = sql + strObj[i] + ")";	
					vSql.add(sql);
				}	
			}
		} 		
		
	}
	
	
  /**
   * getFormCRow            Mehtod 
   *
   * @parm 					int				courseKeyIndex
   * @parm 					String[][]		data
   * @return    			Vector 
   */

	public Vector getFormCRow(int index, String [] data) {
		
		String formCId = "1";
		
		Vector rows = new Vector();

		for (int i = 0; i < data.length; i++) {

			List formcRow = new ArrayList();
			formcRow.add(data[0]);
			formcRow.add(fc.getCourseNoByKey(index));
			formcRow.add(fc.getCourseSectionByKey(index));
			formcRow.add(fc.getCourseTermByKey(index));
			formcRow.add(fc.getCourseYearByKey(index));
			formcRow.add(formCId);
	
			switch (i) {
				case 0:
					break;
	            default:
                	formcRow.add("" + i);
                	formcRow.add(data[i]);
                	rows.add(objectToString(formcRow));
          	}
        } 
        
        return rows;
	}
	
	
  /**
   * objectToString         Mehtod 
   *
   * @parm 					List
   * @return    			String[] 
   */

	public String[] objectToString(List l) {
		String str[] = new String[l.size()];

  		Iterator it = l.iterator(); 
	
		for (int i = 0; it.hasNext(); i++) {
			str[i] = (String) it.next();
		} 		
		
		return str;
	}
	
  /**
   * vectorToString         Mehtod 
   *
   * @parm 					Vector
   * @return    			String[] 
   */

	public String[] vectorToString(Vector v) {
		
		String str[] = new String[v.size()];
		int i = 0;
			
		for (Enumeration e = v.elements(); e.hasMoreElements(); i++) {
			str[i] = (String) e.nextElement();			  	 
		} 		
		
		return str;
	}
	
  /**
   * createFormCSql	        Mehtod 
   *
   * @parm 					String[]
   * @return    			void
   */

	public void createFormCSql(String[] sqlRows) {
	
		try {
			BufferedWriter bw = FileUtil.openOutputFile(new File("FormC.Sql"));
		
			for (int i = 0; i < sqlRows.length; i++) {
				FileUtil.println(bw, sqlRows[i]);
			}
			FileUtil.close(bw);
		}
		catch (FileNotFoundException fnf) {
			fnf.printStackTrace();
		}
		catch (IOException io) {
			io.printStackTrace();		
		}
			
	}	

  /**
   * printSqlRows	        Mehtod 
   *
   * @parm 					String[]
   * @return    			String
   */

	public String printSqlRows(String[] sqlRows) {
			
		String hdr[] = 
		   {Html.getBold(Html.getFont("FormC.SQL Output:", "+2"))};

				
		return
			Html.getHtml(
			  Html.getHead(Html.getTitle("Form C"))+
			  Html.getBody(
				      Html.getBreak() 
					+ Html.getTable(Html.getSheet(hdr), "0", "100%", "nowrap")	
				    + Html.getBreak() 
					+ Html.getTable(Html.getSheet(sqlRows), "0", "100%", "nowrap")	
				    + Html.getBreak()  
				)
			);		
	}	

}	
	